//---------------------------------------------------------------------------
//Program Filtr
//Slou k filtraci vkov sloky
//napsal Jan Havrlnat jako soust diplomov prce
//--Automatizovan tvorba prostorovch model map--
//v roce 2002
//---------------------------------------------------------------------------
#include <vcl.h>
#include <mem.h>
#include <fstream.h>
#include <IniFiles.hpp>
#pragma hdrstop
#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
: TForm(Owner)
{
  // Naten parametr z inicializanho souboru
  TIniFile *ini = new TIniFile("filtr.ini");      
  ScrollBar1->Position = ini->ReadInteger( "Form", "H min", 2 );
  ScrollBar2->Position = ini->ReadInteger( "Form", "H max", 69 );
  ScrollBar3->Position = ini->ReadInteger( "Form", "B min", 50 );
  ScrollBar4->Position = ini->ReadInteger( "Form", "B max", 96 );
  ScrollBar5->Position = ini->ReadInteger( "Form", "S min", 46 );
  ScrollBar6->Position = ini->ReadInteger( "Form", "S max", 100 );
  delete ini;
}
//---------------------------------------------------------------------------
//tlatko Otevt
//oteve bitmapu s obrazem mapy
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  if(OpenDialog1->Execute())
  {            //oteven souboru s bitmapou
    Image1->Picture->LoadFromFile(OpenDialog1->FileName);
    Button3->Enabled=true;          //aktivovn tlatek
    Image2->Width=577;
    Image2->Height=417;
    //nastaven vilikosti zobrazovan bitmapy a nastaven jezdc
    if(Image2->Width>Image1->Picture->Width)Image2->Width=Image1->Picture->Width;
    if(Image2->Height>Image1->Picture->Height)Image2->Height=Image1->Picture->Height;
    ScrollBar7->Max=Image1->Picture->Width-Image2->Width;
    ScrollBar8->Max=Image1->Picture->Height-Image2->Height;
    Image2->Picture->Bitmap->Width=Image2->Width;
    Image2->Picture->Bitmap->Height=Image2->Height;
    Image2->Canvas->Draw(-ScrollBar7->Position,-ScrollBar8->Position,Image1->Picture->Bitmap);
  }
}
//---------------------------------------------------------------------------
//tlatko Selekce
//funkce filtruje obrzek a bitovou mapu ukld do pamti
void __fastcall TForm1::Button3Click(TObject *Sender)
{
  HLSColor hls;
  int a1=ScrollBar1->Position;   //Zjitn intervalu barev
  int a2=ScrollBar2->Position;
  int a3=ScrollBar3->Position;
  int a4=ScrollBar4->Position;
  int a5=ScrollBar5->Position;
  int a6=ScrollBar6->Position;
  int b;
  int he= Image1->Picture->Height ;    //alokace pole pro uloen selektovan bytmapy
  int wi= Image1->Picture->Width;
  delete a;
  a =new char [he*wi/8+1];
  for(b=0;b<he*wi/8+1;b++) a[b]=0;
  ProgressBar1->Max=he;
  ProgressBar1->Position=0;
  int i,j;
  Image1->Picture->Bitmap->PixelFormat= pf24bit;
  Byte *ptr;
  for(j=0;j<he;j++)
  {
    ptr = (Byte *)Image1->Picture->Bitmap->ScanLine[j]; //zskn adresy kad ady pixl
    ProgressBar1->StepIt();
    for(i=0;i<wi;i++)
    {
      b=RGB_TO_HLS(RGBColor(ptr[i*3+2],ptr[i*3+1],ptr[i*3]),hls);  //Konverze z barevnho modelu RGB do HSB
      if(!Hranice(&hls,a1,a2,a3,a4,a5,a6))
      {
        //testuje zadan kritrium
        a[(i+j*wi)/8]=(a[(i+j*wi)/8])^(char)(1<<((i+j*wi))%8); //ukld pixel do pamti
      }
    }
  }

  ProgressBar1->Position=0;

  Image2->Canvas->Draw(-ScrollBar7->Position,-ScrollBar8->Position,Image1->Picture->Bitmap);
  Test(Image2);
  Button3->Enabled=false;
  Button7->Enabled=true;
}
//---------------------------------------------------------------------------
//funkce vypisuje hodnotu barevnch sloek pi kliknut na obrzek
void __fastcall TForm1::Image2MouseUp(TObject *Sender, TMouseButton Button,
                                      TShiftState Shift, int X, int Y)
{
  RGBColor crgb;
  HLSColor hls;
  crgb.barva(Image1->Canvas->Pixels[ScrollBar7->Position+X][ScrollBar8->Position+Y]);
  RGB_TO_HLS(crgb,hls);
  Label13->Caption="H="+(String)(int)hls.h;
  Label14->Caption="S="+(String)(int)hls.s;
  Label15->Caption="B="+(String)(int)hls.b;
}
//---------------------------------------------------------------------------
//Tlatko uloit
//Ulo vyselektovanou bitmapu a jej rozmry do souboru
void __fastcall TForm1::Button7Click(TObject *Sender)
{
  if( SaveDialog1->Execute())
  {
    HANDLE hAppend;
    DWORD del;
    int he=Image1->Picture->Height;
    int wi=Image1->Picture->Width;
    hAppend = CreateFile(SaveDialog1->FileName.c_str(),   // open TWO.TXT
                         GENERIC_WRITE,                // open for writing
                         0,                            // do not share
                         NULL,                         // no security
                         CREATE_ALWAYS  ,         // open or create
                         FILE_ATTRIBUTE_NORMAL,        // normal file
                         NULL);
    WriteFile(hAppend, &he, sizeof(int),
              &del, NULL);
    WriteFile(hAppend, &wi, sizeof(int),
              &del, NULL);
    WriteFile(hAppend, a, Image1->Picture->Height*Image1->Picture->Width/8+1,
              &del, NULL);
    CloseHandle(hAppend);

  }
}
//---------------------------------------------------------------------------
//destruktor
//Ukld nastaven do ini souboru
__fastcall TForm1::~TForm1()
{
  TIniFile *ini = new TIniFile("filtr.ini");
  ini->WriteInteger( "Form", "H min",ScrollBar1->Position );
  ini->WriteInteger( "Form", "H max", ScrollBar2->Position );
  ini->WriteInteger( "Form", "B min", ScrollBar3->Position );
  ini->WriteInteger( "Form", "B max", ScrollBar4->Position );
  ini->WriteInteger( "Form", "S min", ScrollBar5->Position );
  ini->WriteInteger( "Form", "S max", ScrollBar6->Position );
  delete ini;
}
//---------------------------------------------------------------------------
//zobrazuje slo barvy v aktulnm obrzku pi zmknutm tlatku myi
void __fastcall TForm1::Image2MouseDown(TObject *Sender,
                                        TMouseButton Button, TShiftState Shift, int X, int Y)
{

  RGBColor crgb;
  HLSColor hls;
  crgb.barva(Image2->Canvas->Pixels[X][Y]);
  RGB_TO_HLS(crgb,hls);
  Label13->Caption="H="+(String)(int)hls.h;
  Label14->Caption="S="+(String)(int)hls.s;
  Label15->Caption="B="+(String)(int)hls.b;
}
//---------------------------------------------------------------------------
//pohyb po obrzku  vertikln
void __fastcall TForm1::ScrollBar8Change(TObject *Sender)
{

  Image2->Canvas->Draw(-ScrollBar7->Position,-ScrollBar8->Position,Image1->Picture->Bitmap);
}
//---------------------------------------------------------------------------
//pohyb po obrzku   horihontln
void __fastcall TForm1::ScrollBar7Change(TObject *Sender)
{
  Image2->Canvas->Draw(-ScrollBar7->Position,-ScrollBar8->Position,Image1->Picture->Bitmap);
}
//---------------------------------------------------------------------------
//funkce test pro zobrazen vsledn bytmapy
void TForm1::Test(TImage* Image)
{
  if(CheckBox1->Checked)
  {
    HLSColor hls;
    int a1=ScrollBar1->Position;   //Zjitn intervalu barev
    int a2=ScrollBar2->Position;
    int a3=ScrollBar3->Position;
    int a4=ScrollBar4->Position;
    int a5=ScrollBar5->Position;
    int a6=ScrollBar6->Position;
    int he= Image->Picture->Height ;
    int wi= Image->Picture->Width;
    int i,j;
    Image->Picture->Bitmap->PixelFormat= pf24bit;
    Byte *ptr;
    for(j=0;j<he;j++)
    {

      ptr = (Byte *)Image->Picture->Bitmap->ScanLine[j]; //zskn adresy kad ady pixl
      for(i=0;i<wi;i++)
      {
        RGB_TO_HLS(RGBColor(ptr[i*3+2],ptr[i*3+1],ptr[i*3]),hls); //Konverze z barevnho modelu RGB do HSB
        if(!Hranice(&hls,a1,a2,a3,a4,a5,a6)) //Test kritria
        {
          if(!CheckBox2->Checked)
          {  //podbarven obrzku
            ptr[i*3+2] = ptr[i*3+1] = ptr[i*3] = (Byte)0xff;
          }
        }
        else
        {
          ptr[i*3+2] = ptr[i*3+1] = ptr[i*3] = (Byte)0;
        }
      }
    }
    Image->Canvas->Draw(0,0,Image->Picture->Bitmap);
  }
}
//---------------------------------------------------------------------------
//prohlen obrzku
void __fastcall TForm1::ScrollBar7Scroll(TObject *Sender,
                                         TScrollCode ScrollCode, int &ScrollPos)
{
  if(CheckBox1->Checked && ScrollCode==8)
    Test(Image2);
}
//---------------------------------------------------------------------------
//prohlen obrzku
void __fastcall TForm1::ScrollBar8Scroll(TObject *Sender,
                                         TScrollCode ScrollCode, int &ScrollPos)
{
  if(CheckBox1->Checked && ScrollCode==8)
    Test(Image2);
}
//---------------------------------------------------------------------------
//obsluha udlosti zakrtnut polka zapnout Test
void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
  if(CheckBox1->Checked)
  {
    Image2->Canvas->Draw(-ScrollBar7->Position,-ScrollBar8->Position,Image1->Picture->Bitmap);
    Test(Image2);
  }
  else    Image2->Canvas->Draw(-ScrollBar7->Position,-ScrollBar8->Position,Image1->Picture->Bitmap);
}
//---------------------------------------------------------------------------
bool TForm1::Hranice(HLSColor *hls,int a1,int a2,int a3,int a4,int a5,int a6)
{
  if((hls->h>=a1 && hls->h<=a2 && hls->b>=a3 && hls->b<=a4 && hls->s>=a5 && hls->s<=a6))
    return true;
  //  if((hls->h>=a1 && hls->h<=a2 && hls->b>=a3 && hls->b<=a4 && hls->s-hls->h+74-abs(hls->h-54)>=a5 && hls->s<=a6))
  // return true;
  return false;
}
void __fastcall TForm1::CheckBox2Click(TObject *Sender)
{
  Image2->Canvas->Draw(-ScrollBar7->Position,-ScrollBar8->Position,Image1->Picture->Bitmap);
  Test(Image2);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar1Change(TObject *Sender)
{
  Label3->Caption=ScrollBar1->Position;
  Image2->Canvas->Draw(-ScrollBar7->Position,-ScrollBar8->Position,Image1->Picture->Bitmap);
  Test(Image2);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar2Change(TObject *Sender)
{
  Label4->Caption=ScrollBar2->Position;
  Image2->Canvas->Draw(-ScrollBar7->Position,-ScrollBar8->Position,Image1->Picture->Bitmap);
  Test(Image2);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar3Change(TObject *Sender)
{
  Label5->Caption=ScrollBar3->Position;
  Image2->Canvas->Draw(-ScrollBar7->Position,-ScrollBar8->Position,Image1->Picture->Bitmap);
  Test(Image2);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar4Change(TObject *Sender)
{
  Label6->Caption=ScrollBar4->Position;
  Image2->Canvas->Draw(-ScrollBar7->Position,-ScrollBar8->Position,Image1->Picture->Bitmap);
  Test(Image2);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar5Change(TObject *Sender)
{
  Label9->Caption=ScrollBar5->Position;
  Image2->Canvas->Draw(-ScrollBar7->Position,-ScrollBar8->Position,Image1->Picture->Bitmap);
  Test(Image2);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar6Change(TObject *Sender)
{
  Label10->Caption=ScrollBar6->Position;
  Image2->Canvas->Draw(-ScrollBar7->Position,-ScrollBar8->Position,Image1->Picture->Bitmap);
  Test(Image2);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormActivate(TObject *Sender)
{
  Button1Click(Form1);
}
//---------------------------------------------------------------------------
